<?xml version="1.0" encoding="Shift_JIS" ?>
<xsl:stylesheet 
	version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	xmlns:local="#local"
>

<!--
	Purpose	: DicXEBStudiopHTML\[X𐶐XSLT
	Date	: 2005/09/11
	Author	: hishida
-->


<!-- [gvf	-->
	<xsl:template match="/">
		<xsl:apply-templates select="dic-item" />
	</xsl:template>

<!-- dicxvf	-->
<!-- LqȂ -->


<!-- dicx\	-->
	<xsl:template match="dic-item">
		<div>
			<xsl:attribute name="id">
				<xsl:value-of select="@id" />
			</xsl:attribute>
			<xsl:apply-templates />
		</div>
	</xsl:template>

	<xsl:template match="dic-item/head">
		<dt>
			<xsl:value-of select="headword" />
		</dt>
		<xsl:if test="key[@xtype='O']">
			<br /><xsl:value-of select="key[@xtype='O']"/>
		</xsl:if>
		<xsl:apply-templates select="key"/>

	</xsl:template>

	<xsl:template match="dic-item[@type='']/head">
		<dfn>
			<xsl:value-of select="headword" />
		</dfn>
	</xsl:template>


	<xsl:template match="body/meaning|body/example|body/note">
		<xsl:apply-templates />
	</xsl:template>

	<xsl:template match="/dic-item/meaning|/dic-item/example|/dic-item/note|/dic-item/body">
		<dd>
		<xsl:apply-templates />
		</dd>
	</xsl:template>

	<xsl:template match="dic-item[@type='']/meaning|dic-item[@type='']/example|dic-item[@type='']/note|dic-item[@type='']/body">
		<div>
		<xsl:apply-templates />
		</div>
	</xsl:template>


<!-- ========== Xgvf =========== -->
<!-- ӏA`Xgvf -->
	<xsl:template match="ul|ol|li|dl|dt|dd">
		<xsl:copy><xsl:apply-templates/></xsl:copy>
	</xsl:template>


<!-- ========== ubNvf =========== -->

	<xsl:template match="div">
		<div><xsl:apply-templates /></div>
	</xsl:template>

<!-- pOtvfƐ`ς݃eLXgvf -->
	<xsl:template match="p|pre">
		<xsl:copy><xsl:apply-templates/></xsl:copy>
	</xsl:template>



<!-- tablevf -->
	<xsl:template match="table">
		<DIV class="float">
		<TABLE rules="all">
			<xsl:apply-templates  />
		</TABLE>
		</DIV>
	</xsl:template>
	<xsl:template match="table/caption">
		<CAPTION align="bottom">
			<P class="caption-title"><xsl:value-of select="no"/><xsl:value-of select="title"/></P>
			<DIV class="caption-note">
				<xsl:for-each select="p">
					<xsl:apply-templates select="."/>
				</xsl:for-each>
			</DIV>
		</CAPTION>
	</xsl:template>

	<xsl:template match="tr|th|td">
		<xsl:copy><xsl:apply-templates/></xsl:copy>
	</xsl:template>

<!-- floatvf -->
	<xsl:template match="float">
		<DIV class="float">
			<xsl:apply-templates select="@id"/>
			<xsl:apply-templates select="res"/>
			<BR id="" />
			<xsl:apply-templates select="caption"/>
		</DIV>
	</xsl:template>
	<xsl:template match="float/caption">
		<xsl:copy>
			<P class="caption-title"><xsl:value-of select="no"/><xsl:value-of select="title"/></P>
			<DIV class="caption-note">
				<xsl:for-each select="p">
					<xsl:apply-templates select="."/>
				</xsl:for-each>
			</DIV>
		</xsl:copy>
	</xsl:template>

	<xsl:template match="res">
		<IMG>
			<!-- srĉ܂܃Rs[ -->
			<xsl:attribute name="src">
				<xsl:value-of select="@src"/>
			</xsl:attribute>
		</IMG>
	</xsl:template>


<!-- ========== CCvf =========== -->

<!-- spanvf -->

	<xsl:template match="span">
		<xsl:apply-templates/></xsl:template>

	<xsl:template match="span[@type='URL']">
		<A><xsl:attribute name="href"><xsl:apply-templates/></xsl:attribute>
			<xsl:apply-templates/></A></xsl:template>


<!-- refvf -->
	<xsl:template match="ref">
		<A><!-- idrefhref -->
			<xsl:attribute name="href">#<xsl:value-of select="@idref"/></xsl:attribute>
			<xsl:apply-templates/></A></xsl:template>

<!-- keyvf -->
	<xsl:template match="key">
		<xsl:choose>
		<xsl:when test="@xtype='ǂ' or @type='ǂ'">
			<key><xsl:attribute name="type"></xsl:attribute><xsl:apply-templates/></key>
		</xsl:when>
		<xsl:when test="@xtype='L['">
			<xsl:copy>
			<xsl:attribute name="type"></xsl:attribute>
			<xsl:attribute name="name"><xsl:value-of select="@class"/></xsl:attribute>
			<xsl:apply-templates select="node()"/>
			</xsl:copy>
		</xsl:when>
		<xsl:otherwise>
			<key><xsl:attribute name="type">\L</xsl:attribute><xsl:apply-templates/></key>
		</xsl:otherwise>
		</xsl:choose>


	</xsl:template>

<!-- byflowvf -->
<!-- HTMLł͏c͂łȂ̂ŉp̕I -->
	<xsl:template match="byflow"><xsl:apply-templates select="ht"/></xsl:template>

<!-- mlgvf -->
<!-- HTMLł͕\łȂ̂Œʏ̊ʂŊJ -->
	<xsl:template match="mlg">(<xsl:apply-templates/>)</xsl:template>

<!-- rubyvf -->
	<xsl:template match="ruby">
		<!-- ʂŊJꍇ
			<xsl:apply-templates select="rb" />(<xsl:apply-templates select="rt" />)
		-->
		<!-- W3C r^Ogp\ȏꍇ -->
		<RUBY><RB><xsl:apply-templates select="rb"/></RB><RT><xsl:apply-templates select="rt"/></RT></RUBY></xsl:template>

<!-- sup,subvf -->
	<xsl:template match="sup|sub">
		<xsl:copy><xsl:apply-templates/></xsl:copy></xsl:template>

<!-- brvf -->
	<xsl:template match="br">
		<xsl:copy/></xsl:template>

<!-- imgvf -->

	<xsl:template match="img">
		<xsl:choose>
			<xsl:when test="@class='Ɨ'">
				<div class="OutLineImage">
					<img>
						<xsl:attribute name="src"><xsl:value-of select="local:ConvImageFName(string(@src))"/>
						</xsl:attribute>
					</img>
				</div>
			</xsl:when>
			<xsl:when test="@class='O'">
				<img>
					<xsl:attribute name="class">inline</xsl:attribute>
					<xsl:attribute name="src"><xsl:value-of select="local:ConvImageFName(string(@src))"/>
					</xsl:attribute>
				</img>
			</xsl:when>
			<xsl:otherwise>
				<img>
					<xsl:attribute name="src"><xsl:value-of select="local:ConvImageFName(string(@src))"/>
					</xsl:attribute>
				</img>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

<!-- givf -->
	<xsl:template match="gi">
		<xsl:choose>
			<xsl:when test="image">
				<xsl:for-each select="image">
					<img>
						<xsl:attribute name="src"><xsl:value-of select="@source"/></xsl:attribute>
						<xsl:attribute name="align">absmiddle</xsl:attribute>
						<xsl:attribute name="border">0</xsl:attribute>
					</img>
				</xsl:for-each>
			</xsl:when>
			<xsl:when test="uni">
				<xsl:for-each select="uni">
					<xsl:apply-templates select="@code"/>
				</xsl:for-each>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="@alt"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

<!-- id -->
<!-- l𖼑OɂAJ[𐶐 -->
	<xsl:template match="@id">
		<A><xsl:attribute name="name"><xsl:value-of select="."/></xsl:attribute></A>
	</xsl:template>


<!-- emvf -->
<!--
	<xsl:template match="em">
		<STRONG><xsl:apply-templates/></STRONG></xsl:template>
-->

	<xsl:template match="em">
		<xsl:choose>
			<xsl:when test="@class='Α'">
				<i>
					<xsl:apply-templates />
				</i>
			</xsl:when>
			<xsl:when test="@class=''">
				<b>
					<xsl:apply-templates />
				</b>
			</xsl:when>
			<xsl:when test="@class=''">
				<span class="Numeric">
					<xsl:apply-templates />
				</span>
			</xsl:when>
		</xsl:choose>
	</xsl:template>

<msxsl:script language="JavaScript" implements-prefix="local">
<![CDATA[
	// imaget@C .png -> .jpg ɕϊ
	function ConvImageFName( strPat ) {
		strPat = "img/" + strPat.replace(/.png/, ".jpg");
		return strPat;
	}


]]>
</msxsl:script>	

	
</xsl:stylesheet>
