// FontDump.cpp : R\[ AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"
#include "FontDump.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// B̃AvP[V IuWFNg

CWinApp theApp;

using namespace std;

char blankDot	= ' ';

/////////////////////////////////////////////////////////////////////////////
// HEXt@CEBStudioOt@C쐬
/////////////////////////////////////////////////////////////////////////////
int ConvHEX2Txt( TCHAR* pszFileName, 
				int ebCode,		
				int	xsize,			// 0ȊO̎AwidthIɐݒ
				int	ysize,			// 0ȊO̎AheightIɐݒ
				FILE*mapFp,
				int header )
{
	char buf[256];
	FILE* fp = _tfopen( pszFileName, _T("r") );
	if ( fp == NULL )
		return 0;

	unsigned char *lpBits = NULL;
	DWORD dwWidth	= 16;	// hbg\
	DWORD dwHeight	= 16;	// chbg\
	DWORD unicode;

	int lines = 0;
	while( fgets( buf,256, fp ) != NULL ) {
		if ( lines == 0 ) {
			char *s1	= strtok( buf, " \r\n" );
			if ( s1 == NULL )	return 0;
			char *s2	= strtok( NULL, " \r\n" );
			if ( s2 == NULL )	return 0;
			dwWidth		= atoi( s1 );
			dwHeight	= atoi( s1 );

			// hbg\(8,12,16,24,32,48)
			if		( dwWidth<= 8 )	dwWidth	= 8;
			else if ( dwWidth<=12 )	dwWidth	= 12;
			else if ( dwWidth<=16 )	dwWidth	= 16;
			else if ( dwWidth<=24 )	dwWidth	= 24;
			else if ( dwWidth<=32 )	dwWidth	= 32;
			else					dwWidth	= 48;
			// chbg\(16,24,32,48)
			if		( dwHeight<=16 )	dwHeight	= 16;
			else if ( dwHeight<=24 )	dwHeight	= 24;
			else if ( dwHeight<=32 )	dwHeight	= 32;
			else						dwHeight	= 48;
			if ( dwWidth < dwHeight )
				dwWidth = dwHeight / 2;
			if ( dwHeight == 32 )
				dwHeight	= 30;

			// w肪Ƃ͋
			if ( xsize>0 )
				dwWidth	= xsize;
			if ( ysize>0 )
				dwHeight	= ysize;

			lpBits = (unsigned char*)malloc( dwWidth * (dwHeight+1) );
			if ( lpBits==NULL )
				break;

			if ( header ) {
				printf( "<?xml version=\"1.0\" encoding=\"Shift_JIS\"?>\n");
				printf( "<gaijiData xml:space=\"preserve\">\n");
				printf( "<fontSet size=\"%dX%d\" start=\"%X\">\n",dwWidth,dwHeight,ebCode);
				if ( mapFp ) {
					fprintf( mapFp, "<?xml version=\"1.0\" encoding=\"Shift_JIS\"?>\n");
					fprintf( mapFp, "<gaijiSet>\n");
				}
			}

		}
		else {
			char *s_unicode	= strtok( buf, ":" );
			if ( s_unicode == NULL )
				return lines-1;
			sscanf( s_unicode,"%X", &unicode );

			char *bindata	= strtok( NULL, "\r\n" );
			
		// bitmapf[^
			if ( lpBits == NULL ) {
				return 0;
			}
			memset( lpBits, 0, dwWidth * dwHeight );
			// 1byte
			for ( int nbyte =0; nbyte<strlen(bindata)/2 ; ++nbyte ) {
				int bdata;
				sscanf( bindata+nbyte*2,"%02X",&bdata );
				int k = nbyte*8;
				int b = 0x80;
				for ( int ix=0;ix<8;++ix ) {
					if ( k<0 || k>=dwWidth*dwHeight )
						break;
					lpBits[k++] = (bdata & b)>0?1:0;
					b=b>>1;
				}
			}

			// tHgo
			printf( "<fontData ebcode=\"%X\" unicode=\"%X\">\n",
					ebCode,	unicode);
			for ( int hx=0;hx<dwHeight; ++hx ) {
				for ( int wx=0;wx<dwWidth; ++wx ) {
					int dot = lpBits[hx*dwWidth+wx];
					if ( dot ) 
						putchar( '#' );
					else
						putchar( blankDot );
				}
				printf("\n");
			}
			printf( "</fontData>\n");

			if ( mapFp ) {
				fprintf( mapFp, "<gaijiMap unicode=\"#x%04X\" ebcode=\"%04X\"/>\n", 
					unicode, ebCode );
			}
			++ebCode;
			if ( ( ebCode & 0xff ) > 0x7E ) {
				ebCode = ((( ebCode >> 8)+1)<<8) + 0x21;
			}
		}
		++lines;
	}

	fclose( fp );

	if ( lpBits ) 
		free( lpBits );

	if ( header ) {
		printf( "</fontSet>\n" );
		printf( "</gaijiData>\n" );
		if ( mapFp ) {
			fprintf( mapFp, "</gaijiSet>\n" );
		}
	}

	return lines-1;
}


/////////////////////////////////////////////////////////////////////////////
// BDFt@CEBStudioOt@C쐬
/////////////////////////////////////////////////////////////////////////////

typedef struct {
	int encoding;			// ENCODING	(OtCfbNX)
	int FBw,FBh,FBox,FBoy;	// FONTBOUNDINGBOX 
	int BBw,BBh,BBox,BBoy;	// BBX
	int SWx,SWy;			// SWIDTH(gȂ)
	int DWx,DWy;			// DWIDTH(gȂ)
	int xoffs,yoffs;
} BDFChar;

int ConvBDF2Txt( TCHAR* pszFileName, 
				int fromCode,	// JnR[h
				int toCode,		// IR[h
				int ebCode,		
				int unicode,
				int	xsize,			// 0ȊO̎AwidthIɐݒ
				int	ysize,			// 0ȊO̎AheightIɐݒ
				FILE*mapFp,
				int header	)
{
	char buf[256];

	FILE* fp = _tfopen( pszFileName, _T("r") );
	if ( fp == NULL )
		return 0;

	unsigned char *lpBits = NULL;
	DWORD dwWidth	= 16;	// hbg\
	DWORD dwHeight	= 16;	// chbg\

	BDFChar c;
	int _chars	= 0;	// CHARS	fЂ̌
	while( fgets( buf,256, fp ) != NULL ) {
		char *word	= strtok( buf, " \r\n" );
		char *val1,*val2,*val3,*val4;
		if ( word == NULL )	continue;
		if ( strcmp( word, "CHARS" ) == 0 ) {
			if ( ( val1 = strtok( NULL, " \r\n" ) ) == NULL ) break;
			_chars	= atoi( val1 );
		}
		else if ( strcmp( word, "SIZE" ) == 0 ) {
		}
		else if ( strcmp( word, "FONTBOUNDINGBOX" ) == 0 ) {
			if ( ( val1 = strtok( NULL, " \r\n" ) ) == NULL ) break;
			if ( ( val2 = strtok( NULL, " \r\n" ) ) == NULL ) break;
			if ( ( val3 = strtok( NULL, " \r\n" ) ) == NULL ) break;
			if ( ( val4 = strtok( NULL, " \r\n" ) ) == NULL ) break;
			dwWidth	= c.FBw	= atoi( val1 );
			dwHeight= c.FBh	= atoi( val2 );
			if ( *val3 == '-' )
				c.FBox	= atoi( val3+1 ) * -1;
			else 
				c.FBox	= atoi( val3 );
			if ( *val4 == '-' )
				c.FBoy	= atoi( val4+1 ) * -1;
			else 
				c.FBoy	= atoi( val4 );
			if ( c.FBoy > 0 )	// _BOUNDINGBOX̊Oɂꍇ(jiskan16-2000-[12].bdfp␳)
				c.FBoy	*= -1;
			// hbg\(8,12,16,24,32,48)
			if		( dwWidth<= 8 )	dwWidth	= 8;
			else if ( dwWidth<=12 )	dwWidth	= 12;
			else if ( dwWidth<=16 )	dwWidth	= 16;
			else if ( dwWidth<=24 )	dwWidth	= 24;
			else if ( dwWidth<=32 )	dwWidth	= 32;
			else					dwWidth	= 48;
			// chbg\(16,24,32,48)
			if		( dwHeight<=16 )	dwHeight	= 16;
			else if ( dwHeight<=24 )	dwHeight	= 24;
			else if ( dwHeight<=32 )	dwHeight	= 32;
			else						dwHeight	= 48;
			if ( dwWidth < dwHeight )
				dwWidth = dwHeight / 2;
			if ( dwHeight == 32 )
				dwHeight	= 30;

			// w肪Ƃ͋
			if ( xsize>0 )
				dwWidth	= xsize;
			if ( ysize>0 )
				dwHeight	= ysize;

			if ( lpBits != NULL ) {
				return 0;
			}
			lpBits = (unsigned char*)malloc( dwWidth * (dwHeight+1) );
			if ( lpBits==NULL )
				break;

			if ( header ) {
				printf( "<?xml version=\"1.0\" encoding=\"Shift_JIS\"?>\n");
				printf( "<gaijiData xml:space=\"preserve\">\n");
				printf( "<fontSet size=\"%dX%d\" start=\"%X\">\n",dwWidth,dwHeight,ebCode);
				if ( mapFp ) {
					fprintf( mapFp, "<?xml version=\"1.0\" encoding=\"Shift_JIS\"?>\n");
					fprintf( mapFp, "<gaijiSet>\n");
				}
			}

		}
		else if ( strcmp( word, "STARTCHAR" ) == 0 ) {
			c.BBw = c.BBh = c.BBox = c.BBoy	= 0;
			c.SWx = c.SWy = c.DWx = c.DWy	= 0;
			if ( lpBits == NULL ) {
				return 0;
			}
			memset( lpBits,0,dwWidth * dwHeight );
		}
		else if ( strcmp( word, "ENCODING" ) == 0 ) {
			if ( ( val1 = strtok( NULL, " \r\n" ) ) == NULL ) break;
			c.encoding	= atoi( val1 );
		}
		else if ( strcmp( word, "BBX" ) == 0 ) {
			if ( ( val1 = strtok( NULL, " \r\n" ) ) == NULL ) break;
			if ( ( val2 = strtok( NULL, " \r\n" ) ) == NULL ) break;
			if ( ( val3 = strtok( NULL, " \r\n" ) ) == NULL ) break;
			if ( ( val4 = strtok( NULL, " \r\n" ) ) == NULL ) break;
			c.BBw	= atoi( val1 );
			c.BBh	= atoi( val2 );
			if ( *val3 == '-' )
				c.BBox	= atoi( val3+1 ) * -1;
			else 
				c.BBox	= atoi( val3 );
			if ( *val4 == '-' )
				c.BBoy	= atoi( val4+1 ) * -1;
			else 
				c.BBoy	= atoi( val4 );
			c.xoffs	= -c.FBox+c.BBox;
			c.yoffs	= (c.FBh + c.FBoy - c.BBoy) - c.BBh;
		}
		else if ( strcmp( word, "BITMAP" ) == 0 ) {
			int _line = 0;
			while( fgets( buf,256, fp ) != NULL ) {
				if ( strncmp( buf, "ENDCHAR",7 ) == 0 ) {
					if ( fromCode<=c.encoding && c.encoding<=toCode ) {
					/////////////////////////////////////////////////////////////////////////////////////////////
					//	printf("FBw=%d,FBh=%d,FBox=%d,FBoy=%d BBw=%d,BBh=%d,BBox=%d,BBoy=%d xoffs=%d yoffs=%d\n",
					//				c.FBw,c.FBh,c.FBox,c.FBoy,c.BBw,c.BBh,c.BBox,c.BBoy,c.xoffs,c.yoffs);
					/////////////////////////////////////////////////////////////////////////////////////////////
						// tHgo
						printf( "<fontData code=\"%X\"  ebcode=\"%X\" unicode=\"%X\">\n",
								c.encoding, ebCode,	unicode);
						for ( int hx=0;hx<dwHeight; ++hx ) {
							for ( int wx=0;wx<dwWidth; ++wx ) {
								int dot = lpBits[hx*dwWidth+wx];
								if ( dot ) 
									putchar( '#'  );
								else
									putchar( blankDot );
							}
							printf("\n");
						}
						printf( "</fontData>\n");

						if ( mapFp ) {
							fprintf( mapFp, "<gaijiMap unicode=\"#x%04X\" ebcode=\"%04X\"/>\n", 
								unicode, ebCode );
						}

						++unicode;
						++ebCode;
						if ( ( ebCode & 0xff ) > 0x7E ) {
							ebCode = ((( ebCode >> 8)+1)<<8) + 0x21;
						}
					}
					break;
				}
				else {
					// bitmapf[^
					if ( _line < dwHeight ) {
						if ( lpBits == NULL ) {
							return 0;
						}
						// 1byte
						int bmlen = min(c.BBw, dwWidth);
						if ( bmlen%8 != 0 ) 
							bmlen = (bmlen/8)*8 +8;		// 8̔{ɋ
						memset( lpBits+( _line+c.yoffs)*dwWidth,0,dwWidth);
						for ( int nbyte =0; nbyte<bmlen/8 ; ++nbyte ) {
							int bdata;
							sscanf( buf+nbyte*2,"%02X",&bdata );
							int k = ( _line+c.yoffs)*dwWidth+nbyte*8;
							if ( c.xoffs>0 )		k+= c.xoffs;
							else if ( c.xoffs<0 )	k-= c.xoffs;
							int b = 0x80;
							for ( int ix=0;ix<8;++ix ) {
								if ( k<0 || k>=dwWidth*dwHeight )
									break;
								lpBits[k++] = (bdata & b)>0?1:0;
								b=b>>1;
							}
						}
						++_line;
					}
				}
			}
		}
		else if ( strcmp( word, "ENDFONT" ) == 0 ) {
			// t@C̏I
			break;
		}

	}

	fclose( fp );

	if ( lpBits ) 
		free( lpBits );

	if ( header ) {
		printf( "</fontSet>\n" );
		printf( "</gaijiData>\n" );
		if ( mapFp ) {
			fprintf( mapFp, "</gaijiSet>\n" );
		}
	}

	return _chars;
}


/////////////////////////////////////////////////////////////////////////////
// w肵R[hAEBStudioOeLXg`ŏo
/////////////////////////////////////////////////////////////////////////////
int ConvTTF2Txt(	int code,
				DWORD dwWidth, // hbg\(8,12,16,24,32,48)
				DWORD dwHeight, // chbg\(16,24,30,48)
				int ebCode,
				LPCTSTR fontface,
				int unicode,
				int base)
{

	CDC memDC;
	CBitmap bitmap; 
	CFont font;
	// foCXReLXg̍쐬
	memDC.CreateCompatibleDC( NULL ); 

	TCHAR ch[4];
	ch[0] = ch[1] = ch[2] = ch[3] = 0;
#ifdef _UNICODE
	ch[0] = code;
	ch[1] = ' ';
	unicode	= code;
#else
	if ( code <= 255 ) {
		ch[0] = code;
		ch[1] = ' ';
	}
	else {
		ch[0] = code>>8;
		ch[1] = code & 255;
		ch[2] = ' ';
	}
#endif
	CString sch = CString(ch);

	if ( dwWidth>48 )	dwWidth	= 48;
	if ( dwHeight>48 )	dwHeight= 48;
	int size = max(dwWidth,dwHeight);

	// rbg}bv̍쐬
	bitmap.CreateCompatibleBitmap( &memDC, 48, 48 );	// ō48x48
	CBitmap* pOldBitmap = memDC.SelectObject( &bitmap );

	memDC.BitBlt( 0, 0, 48, 48, &memDC, 0, 0, WHITENESS ); // clear

	font.CreatePointFont((int)(size*7.5),fontface);	// |Cg*10

//	double scale = pointSize*10.0/((y==30)?32:y);
//	font.CreatePointFont((int)(((y==30)?32:y)*scale),fontface);	

	CFont* pOldFont = memDC.SelectObject( &font );

	// eLXg̏
	memDC.TextOut( 0, 0, sch ); 


	BYTE lpBits[288];
	bitmap.GetBitmapBits( 288, lpBits );

	WORD	w,b;

	printf( "<fontData ebcode=\"%X\" unicode=\"%X\">\n",ebCode,unicode);

	for ( int j=0+base;j<dwHeight+base; ++j ) {
		int nx = 0;
		for ( int i=0;i<6; ++i ) {
			w = lpBits[j*6+i];
			b = 0x80;
			while ( b>0 ) {
				if ( w & b ) 
					putchar( blankDot );
				else
					putchar( '#'  );
				b = b >> 1;
				++nx;
				if ( nx == dwWidth )
					goto exitloop;
			}
		}
exitloop:
		printf("\n");
	}

	printf( "</fontData>\n");

	memDC.SelectObject( pOldBitmap );
	DeleteObject( bitmap );
	memDC.SelectObject( pOldFont );
	DeleteObject( font );


	return TRUE;

} 


/////////////////////////////////////////////////////////////////////////////
// w肵R[hAw肵TCY2lBMPt@Cɏo
/////////////////////////////////////////////////////////////////////////////
int ConvTTF2BMP(	int code,		// \镶R[h
				DWORD dwWidth,
				DWORD dwHeight,
				LPCTSTR fontface,	// tHgtF[X
				LPCTSTR lpszFileName 
				)
{
	CDC memDC;
	CBitmap bitmap; 
	CFont font;

	if ( dwWidth == 0 || dwHeight==0 )
		return -1;

	TCHAR ch[4];
	ch[0] = ch[1] = ch[2] = ch[3] = 0;
#ifdef _UNICODE
	ch[0] = code;
	ch[1] = ' ';
#else
	if ( code <= 255 ) {
		ch[0] = code;
		ch[1] = ' ';
	}
	else {
		ch[0] = code>>8;
		ch[1] = code & 255;
		ch[2] = ' ';
	}
#endif
	CString sch = CString(ch);

	if ( dwWidth%8 != 0 ) 
		dwWidth = (dwWidth/8)*8 +8;		// 8̔{ɋ
	if ( dwHeight%8 != 0 ) 
		dwHeight = (dwHeight/8)*8 +8;	// 8̔{ɋ
	int size = max(dwWidth,dwHeight);

	// foCXReLXg̍쐬
	memDC.CreateCompatibleDC( NULL ); 

	// rbg}bv̍쐬
	bitmap.CreateCompatibleBitmap( &memDC, dwWidth, dwHeight );
	CBitmap* pOldBitmap = memDC.SelectObject( &bitmap );

	memDC.BitBlt( 0, 0, dwWidth, dwHeight, &memDC, 0, 0, WHITENESS ); // clear

	font.CreatePointFont((int)(size*7.5),fontface);	// |Cg*10

	CFont* pOldFont = memDC.SelectObject( &font );

	// eLXg̏
	memDC.TextOut( 0, 0, sch ); 
	memDC.SelectObject( pOldFont );

	///////////////////////////////////////////////////////////////////////////
	// CBitmap̃t@C
	///////////////////////////////////////////////////////////////////////////
	DWORD dwSize,dwFSize,dwLength;
	HANDLE fh;
	LPBITMAPFILEHEADER lpHead;
	LPBITMAPINFOHEADER lpInfo;
	LPBYTE lpBuf,lpPixel;
	RGBQUAD *lpRGB;

	// ݗpobt@̃TCYvZ
	int rgb_count;
	int _biBitCount = 1;	// 2l̏ꍇ1

	switch ( _biBitCount ) {
	case 1:
		rgb_count = 2;
		dwLength=(((dwWidth / 4) + 3) & 0xfffffffc);
		break;
	case 4:
		rgb_count = 16;
		dwLength=(((dwWidth / 2) + 3) & 0xfffffffc);
		break;
	case 8:
		rgb_count = 256;
		dwLength=((dwWidth + 3) & 0xfffffffc);
		break;
	case 24:
		rgb_count = 0;
		dwLength=((dwWidth * 3 + 3) & 0xfffffffc);
		break;
	}

	dwFSize=  sizeof(BITMAPFILEHEADER)
			+ sizeof(BITMAPINFOHEADER)
			+ sizeof(RGBQUAD)*rgb_count	// J[pbg(2lp)
			+ dwLength*dwHeight;	// rbg}bvC[W

	// obt@mۂƃ|C^ݒ
	lpBuf=(LPBYTE)GlobalAlloc(GPTR,dwFSize);
	lpHead=(LPBITMAPFILEHEADER)lpBuf;
	lpInfo=(LPBITMAPINFOHEADER)(lpBuf+sizeof(BITMAPFILEHEADER));
	lpRGB= (RGBQUAD*)(lpBuf+sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER));
	lpPixel=(lpBuf+sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)+(sizeof(RGBQUAD)*rgb_count));

	// BMPt@C̃wb_쐬
	lpHead->bfType		= 'M'*256+'B';
	lpHead->bfSize		= dwFSize;
	lpHead->bfOffBits	= sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)+(sizeof(RGBQUAD) * rgb_count);

	lpInfo->biSize		= sizeof(BITMAPINFOHEADER);
	lpInfo->biWidth		= dwWidth;
	lpInfo->biHeight	= dwHeight;
	lpInfo->biPlanes	= 1;
	lpInfo->biBitCount	= _biBitCount;

	// GetDIBitsł͑IȂ炵̂
	memDC.SelectObject( pOldBitmap );
	// 
	GetDIBits(	memDC.GetSafeHdc(),
				(HBITMAP)bitmap,
				0,
				dwHeight,
				lpPixel,
				(LPBITMAPINFO)lpInfo,
				DIB_RGB_COLORS );

	// obt@t@Cɏo

	fh=CreateFile(lpszFileName,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
	WriteFile(fh,lpBuf,dwFSize,&dwSize,NULL);
	CloseHandle(fh);

	GlobalFree(lpBuf);

	DeleteObject( bitmap );
	DeleteObject( font );


	return 0;
} 


/////////////////////////////////////////////////////////////////////////////
// main
/////////////////////////////////////////////////////////////////////////////

void usage()
{
	_tprintf( _T("Usage: fontdump {<fontface>|<bdf filename>} <from_code> [<to_code>] [-o=bmp][-e=<ebcode>] [-u=<unicode>] [-x=16] [-y=16] [-m=<gaijimap>][-h]\n") );
}

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// MFC ̏яs̃G[̏o
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: KvɉăG[ R[hύXĂB
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
		// TODO: ̈ʒuɃAvP[V̓LqĂB
		int _x	= 0;
		int _y	= 0;
		int _ebcode = 0xA121;
		int _unicode = 0xE000;
		TCHAR *_fontface = NULL;
		int _codeFrom = 0;
		int _codeTo = 0;
		int _ybase = 0;
		int _header	= 0;
		int _outtype	= 't';	// t:eLXg b:BMP
		CString s;
		TCHAR gaijiMapName[_MAX_FNAME+1] = _T("");


		///////////////////////////////////////////////////////////////
		// IvV̉
		///////////////////////////////////////////////////////////////
		int j=0;
		for ( int i=1; i<argc; ++i ) {
			if ( argv[i][0] == '-' || argv[i][0] == '/' ) {
				switch( argv[i][1] ) {
				case 'e':	// -e=ebcode
					_stscanf( argv[i]+3, _T("%X"), (char*)&_ebcode  );
					break;
				case 'u':	// -u=unicode
					_stscanf( argv[i]+3, _T("%X"), (char*)&_unicode  );
					break;
				case 'm':	// -m=gaijimap.xml
					_tcscpy( gaijiMapName, argv[i]+3 );
					break;
				case 'x':	// -x=16
					_x	= _ttoi( argv[i]+3 );
					break;
				case 'y':	// -y=16
					_y	= _ttoi( argv[i]+3 );
					if ( _y == 32 ) 
						_y	= 30;
					break;
				case 'b':
					_ybase	= _ttoi( argv[i]+3 );
					break;
				case 'o':
					_outtype	=  argv[i][3];
					break;
				case 'h':	// -h
					_header	= 1;
					break;
				case '0':	// -0=.
					blankDot	= argv[i][3];
					break;
				case '?':	// -?
					usage();
					return -1;
					break;
				}
			}
			else {
				switch ( j ) {
				case 0:	// fontface
					_fontface = argv[i];
					break;
				case 1:	// code_from
					_stscanf( argv[i], _T("%X"), (char*)&_codeFrom  );
					_codeTo	= _codeFrom;
					break;
				case 2:	// code_to
					_stscanf( argv[i], _T("%X"), (char*)&_codeTo );
					break;
				}
				++j;
			}
		}
		if ( j<1 ) {
			usage();
			return -1;
		}

		///////////////////////////////////////////////////////////////
		// ϊ̊Jn
		///////////////////////////////////////////////////////////////

		FILE *mapFp = NULL;
		if ( gaijiMapName[0] ) {
			mapFp = _tfopen( gaijiMapName, _T("w") );
		}

		CString sfont = CString(_fontface);
//		if ( strnicmp( _fontface+strlen(_fontface)-4, ".bdf",4 ) == 0 ) {
		if ( sfont.Right(4).CollateNoCase(_T(".bdf")) == 0 ) {
			// BDF̕ϊ
			ConvBDF2Txt( _fontface,		// BDFt@C
						_codeFrom,		// JnR[h(tHg̃OtCfbNX)
						_codeTo,		// IR[h
						_ebcode,		// В`̊JnR[h
						_unicode,		// 蓖ĂUnicode
						_x,				// hbg\(0̎tHgɏ])
						_y,				// chbg\(0̎tHgɏ])
						mapFp,			// GaijiMapo͗pFP
						_header );		// 1:XMLwb_o
		}
//		else if ( strnicmp( _fontface+strlen(_fontface)-4, ".hex",4 ) == 0 ) {
		else if ( sfont.Right(4).CollateNoCase(_T(".hex")) == 0 ) {
			// HEX̕ϊ
			ConvHEX2Txt( _fontface,		// HEXt@C
						_ebcode,		// В`̊JnR[h
						_x,				// hbg\(0̎t@Cwb_ɏ])
						_y,				// chbg\(0̎t@Cwb_ɏ])
						mapFp,			// GaijiMapo͗pFP
						_header );		// 1:XMLwb_o			
		}
		else {	// TTF̕ϊ
			if ( _x == 0 )	_x	= 16;
			if ( _y == 0 )	_y	= 16;

			if ( _header ) {	// XMLwb_쐬
				printf( "<?xml version=\"1.0\" encoding=\"Shift_JIS\"?>\n");
				printf( "<gaijiData xml:space=\"preserve\">\n");
				printf( "<fontSet size=\"%dX%d\" start=\"%X\">\n",_x,_y,_ebcode);
				if ( mapFp ) {
					fprintf( mapFp, "<?xml version=\"1.0\" encoding=\"Shift_JIS\"?>\n");
					fprintf( mapFp, "<gaijiSet>\n");
				}
			}

			while ( _codeFrom <= _codeTo ) {			
				if ( _outtype == 'b' || _outtype == 'B' ) {	// bmp
					// BMPt@Cɏo
					TCHAR _fname[_MAX_FNAME+1];
					_stprintf( _fname,_T("%04X.bmp"),_codeFrom);
					ConvTTF2BMP(
						_codeFrom,	// В`̊JnR[h
						_x,			// hbg\(8,12,16,24,32,48)
						_y,			// chbg\(16,24,30,48)
						_fontface,	// tHgtF[X
						_fname		// o̓t@C
						);
				}
				else {
					// eLXg`ŕWo͂ɏo
					ConvTTF2Txt( 
						_codeFrom,	// В`̊JnR[h
						_x,			// hbg\(8,12,16,24,32,48)
						_y,			// chbg\(16,24,30,48)
						_ebcode,	// В`̊JnR[h
						_fontface,	// tHgtF[X
						_unicode,	// 蓖ĂUnicode
						_ybase		// ỹx[XCItZbg
						 );
				}
				if ( mapFp ) {
					fprintf( mapFp, "<gaijiMap unicode=\"#x%04X\" ebcode=\"%04X\"/>\n", 
						_unicode, _ebcode );
				}

				++_codeFrom;
				++_unicode;
				++_ebcode;
				if ( ( _ebcode & 0xff ) > 0x7E ) {
					_ebcode = ((( _ebcode >> 8)+1)<<8) + 0x21;
				}
			}

			if ( _header ) {	// XMLwb_쐬
				printf( "</fontSet>\n" );
				printf( "</gaijiData>\n" );
				if ( mapFp ) {
					fprintf( mapFp, "</gaijiSet>\n" );
				}
			}
		}
		
		if ( mapFp ) {
			fclose( mapFp );
		}

	}
	return nRetCode;
}


