<?xml version="1.0" encoding="Shift_JIS" ?>
<xsl:stylesheet 
	version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	xmlns:local="#local"
>

<!--
	Purpose	: BTONICiDicXkeyvf𒊏o
	Date	: 2005/09/22
	Author	: hishida
-->


<xsl:template match="/">
	<keys>
	<xsl:apply-templates/>
	</keys>
</xsl:template>


<xsl:template match="dic-item">
	<xsl:if test="@id">
		<span>
		<a>
		<xsl:attribute name="name"><xsl:value-of select="@id"/></xsl:attribute>
		<xsl:attribute name="title">
			<xsl:value-of select="head/headword"/>
<!--			<xsl:value-of select="head/headword[@type='o']"/>-->
			<xsl:value-of select="head/headword[@type='eo']"/>
			<xsl:if test="head/headword[@type='\L']">
				<xsl:text> </xsl:text>
				<xsl:value-of select="head/headword[@type='\L']"/>
			</xsl:if>
		</xsl:attribute>
		<xsl:text></xsl:text>
		</a>
		<xsl:apply-templates select="head/key"/>
		<xsl:if test="not( descendant::dic-item )">
			<xsl:apply-templates select="body//key"/>
		</xsl:if>
		</span>
		<xsl:apply-templates select="descendant::dic-item"/>
	</xsl:if>
</xsl:template>

<xsl:template match="dic-item[@type='']">
	<xsl:if test="@id">
		<span>
		<a>
		<xsl:attribute name="name"><xsl:value-of select="@id"/></xsl:attribute>
		<xsl:attribute name="title">
			<xsl:value-of select="head/headword"/>
<!--			<xsl:value-of select="head/headword[@type='o']"/>-->
			<xsl:value-of select="head/headword[@type='eo']"/>
			<xsl:if test="head/headword[@type='\L']">
				<xsl:text> </xsl:text>
				<xsl:value-of select="head/headword[@type='\L']"/>
			</xsl:if>
		</xsl:attribute>
		<xsl:text></xsl:text>
		</a>
		<xsl:apply-templates select="head/key"/>
		<xsl:apply-templates select="body//key"/>
		</span>
	</xsl:if>
</xsl:template>


<xsl:template match="dic-item//key">
	<xsl:choose>
		<xsl:when test="@type='pL['">
			<xsl:copy>
			<xsl:attribute name="type"></xsl:attribute>
			<xsl:attribute name="name">p</xsl:attribute>
			<xsl:apply-templates select="node()"/>
			</xsl:copy>
		</xsl:when>
		<xsl:when test="ancestor::dic-item[@type='']">
			<xsl:copy>
			<xsl:attribute name="type"></xsl:attribute>
			<xsl:attribute name="name"></xsl:attribute>
			<xsl:apply-templates select="node()"/>
			</xsl:copy>
		</xsl:when>
		<xsl:when test="string-length(@type)=0 or @type='o' or  @type='\L'">
			<xsl:copy-of select="."/>
		</xsl:when>
		<xsl:otherwise>
			<xsl:copy>
			<xsl:attribute name="type"></xsl:attribute>
			<xsl:attribute name="name"><xsl:value-of select="@type"/></xsl:attribute>
			<xsl:apply-templates select="node()"/>
			</xsl:copy>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>


</xsl:stylesheet>
